#include <hmg.ch>

*------------------------------------------------------------------------------*
FUNCTION DoSUP()
*------------------------------------------------------------------------------*
	PRIV nRecno_SUP := 0
	PRIV lNew := .F.
	
	USE SUP alias SUP EXCLUSIVE
	PACK
	INDEX ON SupID TO SUPL01
	INDEX ON STR(SupGrpID) + STR(SupID) TO SUPL02 
	INDEX ON SupNm + STR(SupID) TO SUPL03 
	DbCloseArea()
	
	USE SUP alias SUP NEW SHARED
	SET INDEX TO SUPL01, SUPL02, SUPL03
	
	IF ! IsWindowDefined( Win_SUP_MAIN )
		Load Window Win_SUP_MAIN
		Win_SUP_MAIN.Center 
		Win_SUP_MAIN.Activate
	ENDIF
RETURN

*------------------------------------------------------------------------------*
FUNCTION OnInit_Win_SUP()
*------------------------------------------------------------------------------*
	ON KEY ESCAPE OF Win_SUP_MAIN ACTION ThisWindow.Release
	SUP->(DBSetorder('SUPL01'))
	SUP->(DBGotop())
	Win_SUP_GRID.Browse_SUP.Value := SUP->(recno())
	Win_SUP_GRID.Browse_SUP.Setfocus
RETURN

*------------------------------------------------------------------------------*
FUNCTION SUP_RefreshScreen()
*------------------------------------------------------------------------------*
	SUP_RefreshData()
	Win_SUP_GRID.Browse_SUP.Refresh
	Win_SUP_GRID.Browse_SUP.Setfocus
RETURN 

*------------------------------------------------------------------------------*
FUNCTION SUP_RefreshData()
*------------------------------------------------------------------------------*
	IF Win_SUP_GRID.Browse_SUP.Value == 0
		SUP_Button_Add()
	ELSE
		SUP_Edit()
	ENDIF	
RETURN

*------------------------------------------------------------------------------*
FUNCTION SUP_Button_Add()
*------------------------------------------------------------------------------*
	lNew := .T.
	
	Win_SUP_MAIN.StatusBar.Item(1) := 'Record   ' + LTRIM( STR( SUP->( Lastrec()+1 ) ) ) 
	Win_SUP_MAIN.StatusBar.Item(2) := 'Toevoegen record' 

	Win_SUP_DATA.Text_SupID.Value    := SUP_NewSupID()
	Win_SUP_DATA.Text_SupNm.Value    := ""
	Win_SUP_DATA.Text_Straat.Value   := ""
	Win_SUP_DATA.Text_PostID.Value   := ""
	Win_SUP_DATA.Text_Telnr.Value    := ""
	Win_SUP_DATA.Text_Faxnr.Value    := ""
	Win_SUP_DATA.Text_Banknr.Value   := ""
	Win_SUP_DATA.Text_AgentID.Value  := 0
	Win_SUP_DATA.Label_AgentNm.Value := ""
	
	Win_SUP_DATA.Text_SupID.Enabled  := .T.
	Win_SUP_DATA.Text_SupID.Setfocus 
	Win_SUP_GRID.SUP_Button_Delete.Enabled := .F.
RETURN

*------------------------------------------------------------------------------*
FUNCTION SUP_NewSupID()
*------------------------------------------------------------------------------*
	LOCAL nSupID
	LOCAL nIndex := SUP->(Indexord())
	
	SUP->(DBSetorder('SUPL01') )
	SUP->(DBGoBottom())
	nSupID := SUP->SupID + 1
	SUP->(DBSetorder(nIndex))
RETURN nSupID

*------------------------------------------------------------------------------*
FUNCTION SUP_Edit()
*------------------------------------------------------------------------------*
	lNew := .F.
	
	SUP->(DBGoto( nRecno_SUP := Win_SUP_GRID.Browse_SUP.Value ))
	
	Win_SUP_MAIN.StatusBar.Item(1) := 'Record   ' + LTRIM( STR( SUP->( Recno() ) ) ) + ;
								       ' / ' + LTRIM( STR( SUP->( Lastrec() ) ) )  
	Win_SUP_MAIN.StatusBar.Item(2) := 'Onderhoud record' 

	Win_SUP_DATA.Text_SupID.Value    := SUP->SupID
	Win_SUP_DATA.Text_SupNm.Value    := SUP->SupNm
	Win_SUP_DATA.Text_Straat.Value   := SUP->Straat
	Win_SUP_DATA.Text_PostID.Value   := SUP->PostID 
	Win_SUP_DATA.Text_Telnr.Value    := SUP->Telnr
	Win_SUP_DATA.Text_Faxnr.Value    := SUP->Faxnr
	Win_SUP_DATA.Text_Banknr.Value   := SUP->Banknr
	Win_SUP_DATA.Text_AgentID.Value  := SUP->AgentID
	Win_SUP_DATA.Label_AgentNm.Value := GetSupNm( Win_SUP_DATA.Text_AgentID.Value )
	
	Win_SUP_DATA.Text_SupID.Enabled  := .F.
	Win_SUP_GRID.SUP_Button_Delete.Enabled := .T.
RETURN

*------------------------------------------------------------------------------*
FUNCTION SUP_SortColumn( cSort )
*------------------------------------------------------------------------------*
	SUP->(DBSetorder( cSort ))
	Win_SUP_GRID.Browse_SUP.Refresh
	Win_SUP_GRID.Browse_SUP.Setfocus
RETURN

*------------------------------------------------------------------------------*
FUNCTION SUP_OnEnter_Text_SupID()
*------------------------------------------------------------------------------*
	Win_SUP_DATA.Text_SupNm.Setfocus
RETURN

FUNCTION SUP_OnEnter_Text_SupNm()
	Win_SUP_DATA.Text_Straat.Setfocus
RETURN

FUNCTION SUP_OnEnter_Text_Straat()
	Win_SUP_DATA.Text_PostID.Setfocus
RETURN

FUNCTION SUP_OnEnter_Text_PostID()
	Win_SUP_DATA.Text_Telnr.Setfocus
RETURN

FUNCTION SUP_OnEnter_Text_Telnr()
	Win_SUP_DATA.Text_Faxnr.Setfocus
RETURN

FUNCTION SUP_OnEnter_Text_Faxnr()
	Win_SUP_DATA.Text_Banknr.Setfocus
RETURN

FUNCTION SUP_OnEnter_Text_Banknr()
	Win_SUP_DATA.Text_AgentID.Setfocus
RETURN

FUNCTION SUP_OnEnter_Text_AgentID()
	SUP_Button_Save()
RETURN

*------------------------------------------------------------------------------*
FUNCTION SUP_Button_Save()
*------------------------------------------------------------------------------* 
	LOCAL nSupID    := Win_SUP_DATA.Text_SupID.Value
	LOCAL nAgentID  := Win_SUP_DATA.Text_AgentID.Value
	
	IF lNew == .T.
		IF nSupID <= 0
			MsgSTOP('Nummer leverancier moet > 0' , 'Controle')
			Win_SUP_DATA.Text_SupID.Setfocus
			RETURN Nil
		ENDIF
		
		IF Exist('SUP','SUPL01',nSupID)
			MsgSTOP('Leverancier ' + ALLTRIM(STR(nSupID)) + ' bestaat al' , 'Controle')
			Win_SUP_DATA.Text_SupID.Setfocus
			RETURN Nil
		ENDIF
	ENDIF

	IF EMPTY( Win_SUP_DATA.Text_SupNm.Value )
		MsgSTOP('Naam leverancier is niet ingevuld' , 'Controle')
		Win_SUP_DATA.Text_SupNm.Setfocus
		RETURN Nil
	ENDIF
	
	IF EMPTY( Win_SUP_DATA.Text_Straat.Value )
		MsgSTOP('Straat is niet ingevuld' , 'Controle')
		Win_SUP_DATA.Text_Straat.Setfocus
		RETURN Nil
	ENDIF
		
	IF nAgentID != 0
		IF ! Exist('SUP','SUPL01',nAgentID)
			MsgSTOP("Leverancier " + ALLTRIM(STR(nAgentID)) + " bestaat niet" , 'Controle')
			Win_SUP_DATA.Label_AgentNm.Value := ""
			Win_SUP_DATA.Text_AgentID.Setfocus
			RETURN Nil
		ELSE
			Win_SUP_DATA.Label_AgentNm.Value := SUP->SupNm
		ENDIF
	ELSE
		Win_SUP_DATA.Label_AgentNm.Value := ""
	ENDIF

	IF lNew == .T.
		SUP->(DBAppend())
		SUP->(RLock())
		SUP->SupID := Win_SUP_DATA.Text_SupID.Value
		SUP_UpdDb()
	ELSE
		SUP->(DBGoto( nRecno_SUP ))
		IF RecLocked('SUP')
			SUP_UpdDb()
		ENDIF
	ENDIF
	
	Win_SUP_GRID.Browse_SUP.Value := SUP->(recno())
	SUP_RefreshScreen()
RETURN

*------------------------------------------------------------------------------*
FUNCTION SUP_UpdDb()
*------------------------------------------------------------------------------*
	SUP->SupNm    := Win_SUP_DATA.Text_SupNm.Value
	SUP->Straat   := Win_SUP_DATA.Text_Straat.Value
	SUP->PostID   := Win_SUP_DATA.Text_PostID.Value
	SUP->Telnr    := Win_SUP_DATA.Text_Telnr.Value
	SUP->Faxnr    := Win_SUP_DATA.Text_Faxnr.Value
	SUP->Banknr   := Win_SUP_DATA.Text_Banknr.Value
	SUP->AgentID  := Win_SUP_DATA.Text_AgentID.Value
	SUP->(DBCommit())
	SUP->(DBUnlock())
RETURN

*------------------------------------------------------------------------------*
FUNCTION SUP_Button_Delete()
*------------------------------------------------------------------------------*
	SUP->(DBGoto( nRecno_SUP ))
	IF ! SUP->(EOF())
		IF MsgOkCancel ("Delete leverancier " + ALLTRIM(STR(SUP->SupID)) + " " + ALLTRIM(SUP->SupNm), 'Controle')
					
			IF RecLocked('SUP')
				SUP->(DBDelete())
				SUP->(DBUnlock())
				SUP->(DBSkip())
				IF SUP->(EOF())
					SUP->(DBGoBottom())
				ENDIF
				
				Win_SUP_GRID.Browse_SUP.Value := SUP->(recno())
			ENDIF
		ENDIF
	ENDIF
	Win_SUP_GRID.Browse_SUP.Setfocus
RETURN

*------------------------------------------------------------------------------*
FUNCTION SUP_Button_Refresh()
*------------------------------------------------------------------------------*
	SUP_RefreshScreen()
RETURN

*------------------------------------------------------------------------------*
FUNCTION SUP_Button_Print()
*------------------------------------------------------------------------------*
	LOCAL lSuccess

	SELECT PRINTER DIALOG TO lSuccess PREVIEW

	If lSuccess == .T.
		SUP_PrintDoc()
		* MsgInfo('Print Finished')
	EndIf
RETURN

*------------------------------------------------------------------------------*
PROCEDURE SUP_PrintDoc
*------------------------------------------------------------------------------*
	
RETURN

*------------------------------------------------------------------------------*
FUNCTION SUP_Button_Close()
*------------------------------------------------------------------------------*
	Win_SUP_MAIN.Release
RETURN

*------------------------------------------------------------------------------*
FUNCTION OnRelease_Win_SUP()
*------------------------------------------------------------------------------*
	Win_SUP_DATA.Release
	Win_SUP_GRID.Release
RETURN

*------------------------------------------------------------------------------*
FUNCTION SUP_Button_Select_AgentID()
*------------------------------------------------------------------------------*
	Win_SUP_DATA.Text_AgentID.Setfocus
	Win_SUP_DATA.Text_AgentID.Value  := SUP_Select_SupID( Win_SUP_DATA.Text_AgentID.Value ) 
	Win_SUP_DATA.Label_AgentNm.Value := GetSupNm( Win_SUP_DATA.Text_AgentID.Value )
RETURN

*------------------------------------------------------------------------------*
FUNCTION GetSupNm( nSupID )
*------------------------------------------------------------------------------*
	LOCAL cSupNm 
	IF Exist('SUP','SUPL01',nSupID)
		cSupNm := SUP->SupNm
	ELSE	
		cSupNm := SPACE(len(SUP->SupNm))
	ENDIF
RETURN cSupNm

*------------------------------------------------------------------------------*
FUNCTION SUP_OnDblClick()
*------------------------------------------------------------------------------*
	Win_SUP_DATA.Text_SupNm.Setfocus
RETURN

*------------------------------------------------------------------------------*
*
* Selecteren leverancier
*
*------------------------------------------------------------------------------*
FUNCTION SUP_Select_SupID( nCurSupID )
*------------------------------------------------------------------------------*
	PRIV nIndex_SUP
	PRIV nSupID := nCurSupID
	IF ! IsWindowDefined( Win_SUP_Select )
		Load Window Win_SUP_Select
		Win_SUP_Select.Center 
		Win_SUP_Select.Activate
	ENDIF
RETURN nSupID

*------------------------------------------------------------------------------*
FUNCTION OnInit_Win_SUP_Select()
*------------------------------------------------------------------------------*
	nIndex_SUP := SUP->(Indexord())
	SUP->(DBSetorder('SUPL03'))
	SUP->(DBGotop())
	SUP_Select_RefreshScreen()
RETURN

*------------------------------------------------------------------------------*
FUNCTION SUP_Select_RefreshScreen()
*------------------------------------------------------------------------------*
	Win_SUP_Select.Browse_SUP_Select.Refresh
	Win_SUP_Select.Browse_SUP_Select.Setfocus
RETURN 

*------------------------------------------------------------------------------*
FUNCTION SUP_Select_OnDblClick()
*------------------------------------------------------------------------------*
	SUP_Select_Button_Select()
RETURN

*------------------------------------------------------------------------------*
FUNCTION SUP_Select_Button_Select()
*------------------------------------------------------------------------------*
	SUP->(DBGoto( Win_SUP_Select.Browse_SUP_Select.Value ))
	nSupID := SUP->SupID
	Win_SUP_Select.Release
RETURN 

*------------------------------------------------------------------------------*
FUNCTION OnRelease_Win_SUP_Select()
*------------------------------------------------------------------------------*
	SUP->(DBSetorder(nIndex_SUP))
RETURN

*------------------------------------------------------------------------------*
FUNCTION SetIndexColor( cSort )
*------------------------------------------------------------------------------*
RETURN IF( ORDBAGNAME() == cSort , { 128,255,255 } , { 235,235,235 } )

*------------------------------------------------------------------------------*
FUNCTION RecLocked( cArea )
*------------------------------------------------------------------------------*
	DO WHILE ! (cArea)->(RLock())
		IF ! MSGRetryCancel('Record Lock' , cArea)
			RETURN .F.
		ENDIF
	ENDDO
RETURN .T.

*------------------------------------------------------------------------------*
FUNCTION Exist( cFile, cIndex, xSeekArg, lSoftSeek )
*------------------------------------------------------------------------------*
	LOCAL nIndex := (cFile)->(IndexOrd())
	LOCAL lFound
	DEFAULT lSoftSeek := .F.
	(cFile)->(DBSetorder(cIndex))
	IF (cFile)->(DBSeek( xSeekArg, lSoftSeek ))
		lFound := .T.
	ELSE
		lFound := .F.
	ENDIF
	(cFile)->(DBSetorder(nIndex))
RETURN lFound


